import java.util.List;
import java.util.Map;
import org.openqa.selenium.support.CacheLookup;
import org.openqa.selenium.support.FindBy;
import org.openqa.selenium.support.ui.Select;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;

public class Google2 {
    private Map<String, String> data;
    private WebDriver driver;
    private int timeout = 15;

    @FindBy(css = "a[href='//www.google.com/intl/en/about.html?fg=1']")
    @CacheLookup
    private WebElement about;

    @FindBy(css = "a[class='gb_za gb_0d']")
    @CacheLookup
    private WebElement addAShortcut;

    @FindBy(css = "a[class='gb_Ca gb_Ud gb_nb']")
    @CacheLookup
    private WebElement addAccount;

    @FindBy(css = "a[href='/advanced_search?hl=en&fg=1']")
    @CacheLookup
    private WebElement advancedSearch;

    @FindBy(css = "a[href='//www.google.com/intl/en/ads/?fg=1']")
    @CacheLookup
    private WebElement advertising;

    @FindBy(css = "a[class='gb_Bb gb_Xa']")
    @CacheLookup
    private WebElement allYourGooglePages;

    @FindBy(id = "gb30")
    @CacheLookup
    private WebElement blogger;

    @FindBy(id = "gb10")
    @CacheLookup
    private WebElement books;

    @FindBy(css = "a[href='//www.google.com/services/?fg=1']")
    @CacheLookup
    private WebElement business;

    @FindBy(id = "gb24")
    @CacheLookup
    private WebElement calendar;

    @FindBy(css = "a[class='gb_gb gb_0d gb_ib']")
    @CacheLookup
    private WebElement change;

    @FindBy(id = "gb53")
    @CacheLookup
    private WebElement contacts;

    @FindBy(id = "gb25")
    @CacheLookup
    private WebElement docs;

    @FindBy(id = "gb49")
    @CacheLookup
    private WebElement drive;

    @FindBy(id = "hotword__chw-oe")
    @CacheLookup
    private WebElement enableOkGoogle;

    @FindBy(css = "a[class='gb_la gb_Td']")
    @CacheLookup
    private WebElement evenMoreFromGoogle;

    @FindBy(id = "gb27")
    @CacheLookup
    private WebElement finance;

    @FindBy(css = "#gbw div div.gb_9a.gb_Me.gb_R.gb_Le.gb_Pe div:nth-of-type(1) div:nth-of-type(2) a.gb_P")
    @CacheLookup
    private WebElement gmail1;

    @FindBy(id = "gb23")
    @CacheLookup
    private WebElement gmail2;

    @FindBy(id = "logo")
    @CacheLookup
    private WebElement google1;

    @FindBy(id = "gb119")
    @CacheLookup
    private WebElement google2;

    @FindBy(css = "#viewport div:nth-of-type(7) div:nth-of-type(2) div:nth-of-type(1) div.gb_hb div:nth-of-type(3) a:nth-of-type(1)")
    @CacheLookup
    private WebElement googleProfile;

    @FindBy(name = "btnK")
    @CacheLookup
    private WebElement googleSearch;

    @FindBy(css = "a[href='/history?hl=en&fg=1']")
    @CacheLookup
    private WebElement history;

    @FindBy(id = "gbqfbb")
    @CacheLookup
    private WebElement imFeelingLucky;

    @FindBy(css = "a[href='https://www.google.com/imghp?hl=en&tab=wi&ei=zcSaVt7NIILKjwPxgoXADQ&ved=0EKouCBYoAQ']")
    @CacheLookup
    private WebElement images;

    @FindBy(id = "gb175")
    @CacheLookup
    private WebElement inbox;

    @FindBy(css = "a[href='//support.google.com/websearch/answer/186645?hl=en']")
    @CacheLookup
    private WebElement learnMore1;

    @FindBy(css = "a[href='https://support.google.com/chrome/?p=ui_hotword_search']")
    @CacheLookup
    private WebElement learnMore2;

    @FindBy(id = "lst-ib")
    @CacheLookup
    private WebElement learnMoregoogleInstantIsOffDue;

    @FindBy(id = "gb8")
    @CacheLookup
    private WebElement maps;

    @FindBy(css = "a[class='gb_ka gb_0d']")
    @CacheLookup
    private WebElement more;

    @FindBy(id = "gb192")
    @CacheLookup
    private WebElement myAccount1;

    @FindBy(css = "a[class='gb_Ca gb_Wd gbp1 gb_nb']")
    @CacheLookup
    private WebElement myAccount2;

    @FindBy(id = "gb5")
    @CacheLookup
    private WebElement news;

    @FindBy(id = "hotword__chw-on")
    @CacheLookup
    private WebElement noThanks;

    private final String pageLoadedText = "Say \"Ok Google\" to start a voice search";

    private final String pageUrl = "/Users/rhuang/Github/cli/Google.html";

    @FindBy(id = "gb31")
    @CacheLookup
    private WebElement photos;

    @FindBy(id = "gb78")
    @CacheLookup
    private WebElement play;

    @FindBy(css = "a[href='//www.google.com/intl/en/policies/privacy/?fg=1']")
    @CacheLookup
    private WebElement privacy1;

    @FindBy(css = "a[href='http://www.google.com/intl/en/policies/privacy/']")
    @CacheLookup
    private WebElement privacy2;

    @FindBy(css = "a[class='gb_tb gb_wb']")
    @CacheLookup
    private WebElement richardHuangrickypcgmailComDefault;

    @FindBy(css = "a[href='/setprefs?suggon=2&prev=https://www.google.com/&sig=0_tgbQr2KKV5y7Ia4UeXXh4tkt7Lw%3D']")
    @CacheLookup
    private WebElement screenReaderUsersClickHereTo1;

    @FindBy(id = "csi")
    @CacheLookup
    private WebElement screenReaderUsersClickHereTo2;

    @FindBy(id = "gb1")
    @CacheLookup
    private WebElement search;

    @FindBy(css = "a[href='//support.google.com/websearch/?p=ws_results_help&hl=en&fg=1']")
    @CacheLookup
    private WebElement searchHelp;

    @FindBy(css = "a[href='https://www.google.com/preferences?hl=en&fg=1']")
    @CacheLookup
    private WebElement searchSettings;

    @FindBy(id = "_Yvd")
    @CacheLookup
    private WebElement sendFeedback;

    @FindBy(id = "fsettl")
    @CacheLookup
    private WebElement settings;

    @FindBy(id = "gb6")
    @CacheLookup
    private WebElement shopping;

    @FindBy(id = "gb_71")
    @CacheLookup
    private WebElement signOut;

    @FindBy(css = "a[href='//www.google.com/intl/en/policies/terms/?fg=1']")
    @CacheLookup
    private WebElement terms;

    @FindBy(id = "gb51")
    @CacheLookup
    private WebElement translate;

    @FindBy(id = "gb212")
    @CacheLookup
    private WebElement wallet;

    @FindBy(id = "gb36")
    @CacheLookup
    private WebElement youtube;

    public Google2() {
    }

    public Google2(WebDriver driver) {
        this();
        this.driver = driver;
    }

    public Google2(WebDriver driver, Map<String, String> data) {
        this(driver);
        this.data = data;
    }

    public Google2(WebDriver driver, Map<String, String> data, int timeout) {
        this(driver, data);
        this.timeout = timeout;
    }

    /**
     * Click on About Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickAboutLink() {
        about.click();
        return this;
    }

    /**
     * Click on Add A Shortcut Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickAddAShortcutLink() {
        addAShortcut.click();
        return this;
    }

    /**
     * Click on Add Account Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickAddAccountLink() {
        addAccount.click();
        return this;
    }

    /**
     * Click on Advanced Search Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickAdvancedSearchLink() {
        advancedSearch.click();
        return this;
    }

    /**
     * Click on Advertising Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickAdvertisingLink() {
        advertising.click();
        return this;
    }

    /**
     * Click on All Your Google Pages Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickAllYourGooglePagesLink() {
        allYourGooglePages.click();
        return this;
    }

    /**
     * Click on Blogger Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickBloggerLink() {
        blogger.click();
        return this;
    }

    /**
     * Click on Books Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickBooksLink() {
        books.click();
        return this;
    }

    /**
     * Click on Business Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickBusinessLink() {
        business.click();
        return this;
    }

    /**
     * Click on Calendar Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickCalendarLink() {
        calendar.click();
        return this;
    }

    /**
     * Click on Change Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickChangeLink() {
        change.click();
        return this;
    }

    /**
     * Click on Contacts Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickContactsLink() {
        contacts.click();
        return this;
    }

    /**
     * Click on Docs Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickDocsLink() {
        docs.click();
        return this;
    }

    /**
     * Click on Drive Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickDriveLink() {
        drive.click();
        return this;
    }

    /**
     * Click on Enable Ok Google Button.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickEnableOkGoogleButton() {
        enableOkGoogle.click();
        return this;
    }

    /**
     * Click on Even More From Google Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickEvenMoreFromGoogleLink() {
        evenMoreFromGoogle.click();
        return this;
    }

    /**
     * Click on Finance Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickFinanceLink() {
        finance.click();
        return this;
    }

    /**
     * Click on Gmail Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickGmail1Link() {
        gmail1.click();
        return this;
    }

    /**
     * Click on Gmail Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickGmail2Link() {
        gmail2.click();
        return this;
    }

    /**
     * Click on Google Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickGoogle1Link() {
        google1.click();
        return this;
    }

    /**
     * Click on Google Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickGoogle2Link() {
        google2.click();
        return this;
    }

    /**
     * Click on Google Profile Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickGoogleProfileLink() {
        googleProfile.click();
        return this;
    }

    /**
     * Click on Google Search Button.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickGoogleSearchButton() {
        googleSearch.click();
        return this;
    }

    /**
     * Click on History Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickHistoryLink() {
        history.click();
        return this;
    }

    /**
     * Click on Im Feeling Lucky Button.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickImFeelingLuckyButton() {
        imFeelingLucky.click();
        return this;
    }

    /**
     * Click on Images Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickImagesLink() {
        images.click();
        return this;
    }

    /**
     * Click on Inbox Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickInboxLink() {
        inbox.click();
        return this;
    }

    /**
     * Click on Learn More Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickLearnMore1Link() {
        learnMore1.click();
        return this;
    }

    /**
     * Click on Learn More Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickLearnMore2Link() {
        learnMore2.click();
        return this;
    }

    /**
     * Click on Maps Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickMapsLink() {
        maps.click();
        return this;
    }

    /**
     * Click on More Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickMoreLink() {
        more.click();
        return this;
    }

    /**
     * Click on My Account Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickMyAccount1Link() {
        myAccount1.click();
        return this;
    }

    /**
     * Click on My Account Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickMyAccount2Link() {
        myAccount2.click();
        return this;
    }

    /**
     * Click on News Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickNewsLink() {
        news.click();
        return this;
    }

    /**
     * Click on No Thanks Button.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickNoThanksButton() {
        noThanks.click();
        return this;
    }

    /**
     * Click on Photos Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickPhotosLink() {
        photos.click();
        return this;
    }

    /**
     * Click on Play Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickPlayLink() {
        play.click();
        return this;
    }

    /**
     * Click on Privacy Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickPrivacy1Link() {
        privacy1.click();
        return this;
    }

    /**
     * Click on Privacy Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickPrivacy2Link() {
        privacy2.click();
        return this;
    }

    /**
     * Click on Richard Huangrickypcgmail Com Default Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickRichardHuangrickypcgmailComDefaultLink() {
        richardHuangrickypcgmailComDefault.click();
        return this;
    }

    /**
     * Click on Search Help Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickSearchHelpLink() {
        searchHelp.click();
        return this;
    }

    /**
     * Click on Search Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickSearchLink() {
        search.click();
        return this;
    }

    /**
     * Click on Search Settings Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickSearchSettingsLink() {
        searchSettings.click();
        return this;
    }

    /**
     * Click on Send Feedback Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickSendFeedbackLink() {
        sendFeedback.click();
        return this;
    }

    /**
     * Click on Settings Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickSettingsLink() {
        settings.click();
        return this;
    }

    /**
     * Click on Shopping Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickShoppingLink() {
        shopping.click();
        return this;
    }

    /**
     * Click on Sign Out Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickSignOutLink() {
        signOut.click();
        return this;
    }

    /**
     * Click on Terms Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickTermsLink() {
        terms.click();
        return this;
    }

    /**
     * Click on Translate Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickTranslateLink() {
        translate.click();
        return this;
    }

    /**
     * Click on Wallet Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickWalletLink() {
        wallet.click();
        return this;
    }

    /**
     * Click on Youtube Link.
     *
     * @return the Google2 class instance.
     */
    public Google2 clickYoutubeLink() {
        youtube.click();
        return this;
    }

    /**
     * Fill every fields in the page.
     *
     * @return the Google2 class instance.
     */
    public Google2 fill() {
        setScreenReaderUsersClickHereTo2TextareaField();
        setLearnMoregoogleInstantIsOffDueTextField();
        return this;
    }

    /**
     * Fill every fields in the page and submit it to target page.
     *
     * @return the Google2 class instance.
     */
    public Google2 fillAndSubmit() {
        fill();
        return submit();
    }

    /**
     * Set default value to Learn Moregoogle Instant Is Off Due To Connection Speed Text field.
     *
     * @return the Google2 class instance.
     */
    public Google2 setLearnMoregoogleInstantIsOffDueTextField() {
        return setLearnMoregoogleInstantIsOffDueTextField(data.get("LEARN_MOREGOOGLE_INSTANT_IS_OFF_DUE"));
    }

    /**
     * Set value to Learn Moregoogle Instant Is Off Due To Connection Speed Text field.
     *
     * @return the Google2 class instance.
     */
    public Google2 setLearnMoregoogleInstantIsOffDueTextField(String learnMoregoogleInstantIsOffDueValue) {
        learnMoregoogleInstantIsOffDue.sendKeys(learnMoregoogleInstantIsOffDueValue);
        return this;
    }

    /**
     * Set default value to Screen Reader Users Click Here To Turn Off Google Instant Textarea field.
     *
     * @return the Google2 class instance.
     */
    public Google2 setScreenReaderUsersClickHereTo1TextareaField() {
        return setScreenReaderUsersClickHereTo1TextareaField(data.get("SCREEN_READER_USERS_CLICK_HERE_TO_1"));
    }

    /**
     * Set value to Screen Reader Users Click Here To Turn Off Google Instant Textarea field.
     *
     * @return the Google2 class instance.
     */
    public Google2 setScreenReaderUsersClickHereTo1TextareaField(String screenReaderUsersClickHereTo1Value) {
        screenReaderUsersClickHereTo1.click();
        return this;
    }

    /**
     * Set default value to Screen Reader Users Click Here To Turn Off Google Instant Textarea field.
     *
     * @return the Google2 class instance.
     */
    public Google2 setScreenReaderUsersClickHereTo2TextareaField() {
        return setScreenReaderUsersClickHereTo2TextareaField(data.get("SCREEN_READER_USERS_CLICK_HERE_TO_2"));
    }

    /**
     * Set value to Screen Reader Users Click Here To Turn Off Google Instant Textarea field.
     *
     * @return the Google2 class instance.
     */
    public Google2 setScreenReaderUsersClickHereTo2TextareaField(String screenReaderUsersClickHereTo2Value) {
        screenReaderUsersClickHereTo2.sendKeys(screenReaderUsersClickHereTo2Value);
        return this;
    }

    /**
     * Submit the form to target page.
     *
     * @return the Google2 class instance.
     */
    public Google2 submit() {
        clickImFeelingLuckyButton();
        return this;
    }

    /**
     * Verify that the page loaded completely.
     *
     * @return the Google2 class instance.
     */
    public Google2 verifyPageLoaded() {
        (new WebDriverWait(driver, timeout)).until(new ExpectedCondition<Boolean>() {
            public Boolean apply(WebDriver d) {
                return d.getPageSource().contains(pageLoadedText);
            }
        });
        return this;
    }

    /**
     * Verify that current page URL matches the expected URL.
     *
     * @return the Google2 class instance.
     */
    public Google2 verifyPageUrl() {
        (new WebDriverWait(driver, timeout)).until(new ExpectedCondition<Boolean>() {
            public Boolean apply(WebDriver d) {
                return d.getCurrentUrl().contains(pageUrl);
            }
        });
        return this;
    }
}
